require 'sketchup.rb'
require 'extensions.rb'
require 'langhandler.rb'

module JWMPlugins
  module WD_InputBox

    # Constant for language strings swapping...
#     wdIBLH = LanguageHandler.new('wd_InputBox')

    # Constants to make the code independent of the Plugins folder
    BASEPATH = File.dirname(__FILE__).freeze
    EXTPATH = File.join(BASEPATH, 'JWM_wd_InputBox').freeze
#     IMGPATH = File.join(EXTPATH, 'Images').freeze

    # Load the extension.
    extension_name = 'JWM_wd_InputBox'
    loader = File.join(EXTPATH, 'JWM_wd_InputBox.rb')
    extension = SketchupExtension.new(extension_name, loader)
    extension.description = 'Create a simple WebDialogue Input Box'+ "\n" +
                            ' with select, numeric, integer, length or filename input fields ' + "\n" +
                            ' with type validation, and range checks on numeric and integer values.'
    extension.version = '0.52'
    extension.creator = 'John McClenahan'
    extension.copyright = '2016, john.mcclenahan@gmail.com'

    Sketchup.register_extension extension, true
  end # WD_InputBox
end # JWMPlugins
