# JWM_wd_InputBox.rb
# To load in Ruby console, enter this (edit to suit where you have put this file):
# load "JWM_wd_InputBox/JWM_wd_InputBox.rb"

# Code to set up a WebDialog input form and send/receive values to/from it
# MIT licence
# John McClenahan 2106-09-30
# v0.50
#   Renamed functions in both JS and Ruby to better reflect what they do
# v0.51
#    Added check for all-fields valid to button_clicked function in HTML page
#   Added extensive error checking (but not working properly) in HTHML page
# v0.52
#   Got error checking working in HTML page and sending (only) valid data to Ruby
# v0.53
# Tidying up the HTML page and JS code

# This code started from Martin Rinehart's example WebDialog code...

require 'sketchup.rb'

# Parameters for WebDialog.new
# Caption, scrollable (always behaves as if 'true' in Windows), Windows Registry Key name (to remember window size and location), dialogue width, height, left and top offset, and resizeable? (seems to make no difference on Mac - it's always resizeable)

wd=UI::WebDialog.new(
	"JWM_wd_InputBox", true, "JWM_wd_InputBox", 500, 300, 200, 200, false )

# This callback function is triggered when user clicks WebDialog OK button to get inputs
# via string 'message'
wd.add_action_callback("get_inputs") do |js_wd, message|
# translate html single and double quotes back to foot/inch marks
	message = message.gsub("&apos;", "'");
	message = message.gsub("&quot;", '"');
# replace double spaces if any by single ones
	message.gsub("  "," ");
	message.gsub("  "," ");
	get_result = message
 puts get_result; # Put your own code here to decode inputs received
	js_wd.execute_script( get_result )

# Uncomment following line after finishing testing, to close dialog after OK button clicked
# wd.close
end

# This function responds to JS request to set values in form, from Ruby code,
# and enter them into the WebDialog input boxes
# Replace the sentValues string with your own values from your Ruby plugin
# Make sure to encode foot and inch marks (single and double quotes) with
#  HTML equivalents before sending them

wd.add_action_callback("set_values") do |js_wd, message|
#  puts "set_values called with message = " + message;
  sentValues = 'one|2.22|33|44 1/4&quot;|saveAsName'
# The value to L of = sign below is the name of the Ruby variable containing the JS string to be
#   sent to JS to be executed in the WebDialogue
# The function to R of = sign is the name of the JS function that reads the message from Ruby
  set_result = 'set_inputs("'  + sentValues + '");'
 puts set_result;
	js_wd.execute_script( set_result );

end
# Set the filename and path for your web dialogue HTML file
pathname = Sketchup.find_support_file( 'JWM_wd_InputBox.html', 'Plugins/JWM_wd_InputBox/' )
# puts "pathname = "  + pathname
wd.set_file( pathname  )

wd.show_modal()

# end of sample3.rb
